
package fibonacci;

import salsa.language.*;

public class Fibonacci extends Actor {
    
    static StandardOutput standardOutput = new StandardOutput();
 
    int n;
    
    Fibonacci(int n){
	this.n = n;
    }

    public int compute(Message _currentMessage){
	if (n == 0){
	    return 0;
	} else if (n <= 2){
	    return 1;
	} else {
	    Fibonacci fib1 = new Fibonacci(n-1);
	    Fibonacci fib2 = new Fibonacci(n-2);
// 	    join (fib1<-compute(), fib2<-compute())
//                  @ add @ currentContinuation;
	    try {
		MessageGroup messageGroup = null;
		{
		    Actor[] targets = {fib1, fib2};
		    String[] methodNames = { "compute", "compute" };
		    Object[][] arguments = { { null } , { null } };
		    int[] tokenPositions = { -2, -2 };
		    Message continuation = null;
		    int[] returnValues = { };  // to get types of return values
		    {
			//  -> add -> currentContinuation;
			Actor[] continuationTargets = { this };
			String[] continuationMethodNames = { "add" };
			Object[][] continuationArguments = { { null } };
			int[] continuationTokens = {0};
			
			continuation =
			    Message.createMessage
			    (this,
			     continuationTargets,
			     continuationMethodNames,
			     continuationArguments,
			     continuationTokens,
			     returnValues.getClass(),
			     0);
			continuation.setLastContinuation
			    (_currentMessage.getContinuation());
			_currentMessage.setContinuation(null);
		    } 
		    messageGroup =
			MessageGroup.createMessageGroup
			(this,
			 targets,
			 methodNames,
			 arguments,
			 tokenPositions,
			 continuation);
		}
		//  messageGroup:process();
		{
		    Actor[] targets = {messageGroup};
		    String[] methodNames = {"process"};
		    Object[][] arguments = { {} };
		    int [] tokens = {-1};
		    messageGroup.send
			(Message.createMessage
			 (this,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
		}
	    } catch (NoSuchMessageException nsme){
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	    return 0;  
	    // will be discarded, since continuation has been set to null.
	}
    }

    public int add(int numbers[]){
	return numbers[0]+numbers[1];
    }

    public void act(String args[]){
//         compute() @ standardOutput<-println;
	{
	    Actor[] targets = { this, standardOutput };
	    String[] methodNames = { "compute", "println" };
	    Object[][] arguments = { { null },
				     { null }
	                           };
	    int [] tokens = {-2, 0};
	    try {
		this.send
		    (Message.createMessage
		     (this,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		System.err.println(nsme);
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}
    }

    public static void main(String args[]){
	Fibonacci _fibonacci = new Fibonacci();
	// _fibonacci<-act(args);
	{
	    Actor[] targets = { _fibonacci };
	    String[] methodNames = { "act" };
	    Object[][] arguments = { { args } };
	    int [] tokens = { -1 };
	    try {
		_fibonacci.send
		    (Message.createMessage
		     (null,  // no initial sender
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		System.err.println(nsme);
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}
    }
}
