package language;

import salsa.language.Actor;

public class TokenPrinter extends Actor{
    public int compute(){
	return 5;
    }
    public String computeString(){
	return "a string";
    }
    public Object computeObject(){
	return new Integer(5);
    }
    public void print(int number){
	System.out.println(number+2);
    }
    // This one will not work because SALSA converts
    // Wrapper types into primitive types when looking
    // for which method to apply.  
    // See: salsa.lang.Message.createMessage(...)
    public void print(Integer number){
	System.out.println(number);
    }
    public void print(String string){
	System.out.println(string+" indeed.");
    }
    // This one is more general and should NOT be chosen
    // for int and String:
    public void print(Object object){
	System.out.println("Object:" + object);
 	die();
    }
    public static void main(String[] args){
	TokenPrinter printer = new TokenPrinter();
	//  SALSA Code:
	//   printer:compute() -> printer:print;
	//
	//  OR equivalent code:
	//
	//   printer:compute() -> printer:print(token);
	//
	printer.send(printer, "compute", printer, "print", true);
	printer.send(printer, "computeString", printer, "print", true);
	printer.send(printer, "computeObject", printer, "print", true);

    }
}
