/* SALSA/World Wide Computer Porject
 *
 * Reference Server - Remote Message Sending Protocol Daemon
 * In order to deliver a message to a remote actor, messengers
 * reach this daemon (that can also host actors) to get the (unique)
 * hash code of the target actor. The rmspd is in charge to forward
 * messengers to the target's stage (rmspd's host or remote applet).
 *
 * By Gregory Haik and Carlos Varela.  v0.1  June, 1999
 *
 */
package wwc.messaging;

import wwc.util.ObjectiveRequest;

/**
 * Defines the request sent to the rmspd when an actor has left a stage
 * handled by the rmspd.
 */
public class EmigratingActorNotification extends ObjectiveRequest {
    String relativeUAL;
    public EmigratingActorNotification(String hostname,
				       int portNumber,
				       String localUAL) {
	senderHostname = hostname;
	senderPortNumber = portNumber;
	relativeUAL = localUAL;
    }
    
    public String getRelativeUAL() {
	return relativeUAL;
    }
}
