package wwc.proxy;

import java.net.*;
import salsa.language.*;

/**
 * Designed to be run on a machine which hosts a bit of the World Wide Computer.
 * It's supposed to accept ProxyActor connections and handle them.
 *
 * @author Robin D. Toll
 * @version 0.12.5.2001
 */
public class ProxyDaemon extends Thread {
	private int LISTEN_SOCKET = 5050;
	private boolean flag = true;

	public static void main(String[] argv) {
		new ProxyDaemon(argv).start();
	}

	public ProxyDaemon(String[] argv) {
		for (int x=0; x<argv.length; x++) {
			if (((argv[x].equals("-p")) || (argv[x].equals("-P"))) && (x<(argv.length-1))) {
				x++;
				try {
					LISTEN_SOCKET = Integer.parseInt(argv[x]);
				} catch (Exception e) {
					LISTEN_SOCKET = 5050;
					System.err.println("Invalid port number.");
				}
			}
			else if (argv[x].equals("-?"))
				help();
//FIXME
System.out.println(argv[x]);
		}
	}

	public void run() {
		System.out.println("Serving Proxies...");
		try {
			ServerSocket mySS = new ServerSocket(LISTEN_SOCKET);
			LISTEN_SOCKET = mySS.getLocalPort();
			flag = true;
			while (flag) {
				try {
					Socket tmp = mySS.accept();
					new ProxyActorServer(tmp.getOutputStream(), tmp.getInputStream()).start();
					//new ProxyActorServer(mySS.accept()).start();
				} catch (Exception e) {
e.printStackTrace();
					// Well, we really don't care too much...  Do we?
				}
			}
		} catch (Exception e) {
			System.err.println(e);
		}
	}

	public int getListenSocket() {
		return LISTEN_SOCKET;
	}

	public void end() {
		flag = false;
	}

	private void help() {
		System.out.println("Help Information...");
		System.exit(0);
	}
}
